package portablesimulator;

import javax.swing.SwingUtilities;
import portablesimulator.csv.PSConfig;
import portablesimulator.csv.Repository;
import portablesimulator.gui.PSFrame;
import portablesimulator.gui.themes.ThemeManager;

public class PSApp {

    /**
     * Main method launching the application.
     */
    public static void main(String[] args) {
        //System.setProperty("awt.useSystemAAFontSettings", "on");
        //System.setProperty("swing.aatext", "true");

        Repository.init();

        SwingUtilities.invokeLater(new Runnable() {

            public void run() {
                final PSConfig config = Repository.getConfig();

                final PSFrame mainFrame = new PSFrame(config.lastSession);

                SwingUtilities.invokeLater(new Runnable() {

                   
                    public void run() {
                        ThemeManager.setMetalTheme(config.themeNumber);
                        ThemeManager.setFont(config.fontName, config.fontStyle, config.fontSize);
                        ThemeManager.updateUITree();
                        mainFrame.setVisible(true);
                        mainFrame.doStyleResultList(true);
                        mainFrame.doStyleMysetList(true, "");
                    }
                });
            }
        });
    }
}
