package portablesimulator.csv;

import java.util.HashMap;
import portablesimulator.PSItem;
import portablesimulator.PSItemType;
import portablesimulator.skillset.SkillSet;

public class PSSession {
    public int searchHunterRank = 6;
    public int searchTownRank = 6;
    public int searchGenderType = 1;
    public int searchHunterType = 1;
    public int searchWeaponSlotCount = 0;
    public long searchMaxCount = 9999;
    public boolean searchMatome = true;
    public boolean searchFukugo = true;
    public boolean searchPlusAlpha = false;
    public boolean searchPlusOneFast = false;
    public boolean searchCharmMatome = false;
    public int searchCharmCSVLevel = 0;
    public boolean searchWithUsableStatus = false;
    public boolean searchOrderByDeffence = false;
    public SkillSet searchSkills = new SkillSet();
    public PSSearchItems items = new PSSearchItems();

    public PSSession makeCopy() {
        PSSession obj = new PSSession();
        obj.searchHunterRank = this.searchHunterRank;
        obj.searchTownRank = this.searchTownRank;
        obj.searchGenderType = this.searchGenderType;
        obj.searchHunterType = this.searchHunterType;
        obj.searchWeaponSlotCount = this.searchWeaponSlotCount;
        obj.searchOrderByDeffence = this.searchOrderByDeffence;
        obj.searchMaxCount = this.searchMaxCount;
        obj.searchMatome = this.searchMatome;
        obj.searchFukugo = this.searchFukugo;
        obj.searchPlusAlpha = this.searchPlusAlpha;
        obj.searchPlusOneFast = this.searchPlusOneFast;
        obj.searchCharmMatome = this.searchCharmMatome;
        obj.searchCharmCSVLevel = this.searchCharmCSVLevel;
        obj.searchWithUsableStatus = this.searchWithUsableStatus;
        obj.searchSkills = new SkillSet();
        obj.searchSkills.sum_all(this.searchSkills);
        return obj;
    }

    public boolean isExistForThisHunter(PSItem item) {
        if (item.itemType == PSItemType.TYPE_CHARM) {
            return true;
        }
        if (item.itemType == PSItemType.TYPE_DECORATION) {
            return true;
        }
        if (item.existHunterRank <= searchHunterRank
                || item.existTownRank <= searchTownRank) {
            if (item.genderType == 0 || item.genderType == searchGenderType) {
                if (item.hunterType == 0 || item.hunterType == searchHunterType) {
                    return true;
                }
            }
        }
        return false;
    }

    public boolean isExistForNegativeSkill(SkillSet skills, PSItem item) {
        for (int i = 0; i < skills.size(); ++i) {
            for (int j = 0; j < item.skills.size(); ++j) {
                if (skills.kind(i) == item.skills.kind(j)) {
                    if (skills.positive(i)) {
                        if (item.skills.point(j) < 0) {
                            return true;
                        }
                    } else {
                        if (item.skills.point(j) > 0) {
                            return true;
                        }
                    }
                }
            }
        }
        return false;
    }

    public boolean isExistForSkill(SkillSet skills, PSItem item) {
        for (int i = 0; i < skills.size(); ++i) {
            for (int j = 0; j < item.skills.size(); ++j) {
                if (skills.kind(i) == item.skills.kind(j)) {
                    if (skills.positive(i)) {
                        if (item.skills.point(j) > 0) {
                            return true;
                        }
                    } else {
                        if (item.skills.point(j) < 0) {
                            return true;
                        }
                    }
                }
            }
        }
        return false;
    }
}
