package portablesimulator.skillset;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.TreeSet;
import portablesimulator.csv.PSSession;

public class SkillFukugo {
    public Map<SkillPoint, ArrayList<SkillPoint>> mapFukugo = new HashMap<SkillPoint, ArrayList<SkillPoint>>();

    public TreeSet<SkillSet> searchFilter(PSSession session) {
        return searchFilter(session, session.searchSkills);
    }

    public TreeSet<SkillSet> searchFilter(PSSession session, SkillSet set) {
        TreeSet<SkillSet> result = new TreeSet<SkillSet>();

        if (session.searchFukugo == false) {
            result.add(set);
            return result;
        }

        for(SkillPoint point : mapFukugo.keySet()) {
            ArrayList<SkillPoint> list = mapFukugo.get(point);

            boolean mod = false;
            SkillSet newSet = new SkillSet();
            newSet.set_all(set);

            for (SkillPoint p : list) {
                if (p.positiveRange) {
                    SkillKind skind = p.skillKind;
                    int src_point = p.skillPoint;

                    int x = newSet.indexOfKind(skind);
                    if (x < 0) {
                        continue;
                    }
                    int target_point = newSet.point(x);

                    if (src_point >= target_point) {
                        newSet.removeAtIndex(x);
                        newSet.set(point.skillKind, point.skillPoint, point.positiveRange);
                        mod = true;
                    }
                }
            }
            if (mod) {
                TreeSet<SkillSet> newList = searchFilter(session, newSet);
                result.addAll(newList);
            }
        }
        result.add(set);
        return result;
    }
}
